unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, DBGrids,
  SQLDB, DB, SQLite3Conn;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnCreateTable1: TButton;
    btnCreateTable2: TButton;
    chbPopulateHiddenField: TCheckBox;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    SQLConnector1: TSQLConnector;
    SQLQuery1: TSQLQuery;
    SQLQuery2: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure btnCreateTable1Click(Sender: TObject);
    procedure btnCreateTable2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SQLQueryBeforePost(DataSet: TDataSet);
  private
    procedure CreateFields(sqlQuery: TSQLQuery);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnCreateTable1Click(Sender: TObject);
var
  i: Integer;
begin
  SQLQuery1.SQL.Text := 'create table testchar (field1 Char(2000), field2 Char(2000), field3 Char(2000), hiddenfield Char(2000))';
  SQLQuery1.ExecSQL;

  CreateFields(SQLQuery1);

  SQLQuery1.SQL.Text := 'select * from testchar';
  SQLQuery1.Open;

  btnCreateTable1.Enabled := False;
end;

procedure TForm1.btnCreateTable2Click(Sender: TObject);
var
  i: Integer;
begin
  SQLQuery2.SQL.Text := 'create table testwidechar (field1 WideChar, field2 WideChar, field3 WideChar, hiddenfield WideChar)';
  SQLQuery2.ExecSQL;

  CreateFields(SQLQuery2);

  SQLQuery2.SQL.Text := 'select * from testwidechar';
  SQLQuery2.Open;

  btnCreateTable2.Enabled := False;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  SQLConnector1.DatabaseName := ParamStr(0)+'test.db';
  //ShowMessage(SQLConnector1.DatabaseName);
  if FileExists(SQLConnector1.DatabaseName)
  then DeleteFile(SQLConnector1.DatabaseName);
end;

procedure TForm1.SQLQueryBeforePost(DataSet: TDataSet);
begin
  if chbPopulateHiddenField.Checked
  then DataSet.FieldByName('hiddenfield').Value := 'x'
end;

procedure TForm1.CreateFields(sqlQuery: TSQLQuery);
begin
  // add fields
  sqlQuery.Fields.Clear;

  with TStringField.Create(sqlQuery) do
  begin
    FieldName    := 'field1';
    DisplayLabel := 'Field 1';
    DataSet      := sqlQuery;
    DisplayWidth := 15;
    Size         := 2000;
  end;

  with TStringField.Create(sqlQuery) do
  begin
    FieldName    := 'field2';
    DisplayLabel := 'Field 2';
    DataSet      := sqlQuery;
    DisplayWidth := 15;
    Size         := 2000;
  end;

  with TStringField.Create(sqlQuery) do
  begin
    FieldName    := 'field3';
    DisplayLabel := 'Field 3';
    DataSet      := sqlQuery;
    DisplayWidth := 15;
    Size         := 2000;
  end;

  with TStringField.Create(sqlQuery) do
  begin
    FieldName    := 'hiddenfield';
    DisplayLabel := 'Hidden Field';
    DataSet      := sqlQuery;
    DisplayWidth := 15;
    Size         := 2000;
    Visible      := False;
  end;

end;

end.

